"""
Django settings for codex_app project.

Generated by 'django-admin startproject' using Django 3.2.8.

For more information on this file, see
https://docs.djangoproject.com/en/3.2/topics/settings/

For the full list of settings and their values, see
https://docs.djangoproject.com/en/3.2/ref/settings/
"""

from pathlib import Path

# Build paths inside the project like this: BASE_DIR / 'subdir'.
BASE_DIR = Path(__file__).resolve().parent.parent

# Quick-start development settings - unsuitable for production
# See https://docs.djangoproject.com/en/3.2/howto/deployment/checklist/

# SECURITY WARNING: keep the secret key used in production secret!
SECRET_KEY = "django-insecure-430-^*j!q4jkjnl+8)6vod6st6@)j+5-lm-k%+o#9hu9h-t6$v"

# SECURITY WARNING: don't run with debug turned on in production!
DEBUG = True

ALLOWED_HOSTS = ["*"]

INTERNAL_IPS = [
    "127.0.0.1",
]

# Application definition

INSTALLED_APPS = [
    "django.contrib.admin",
    "django.contrib.auth",
    "django.contrib.contenttypes",
    "django.contrib.sessions",
    "django.contrib.messages",
    "django.contrib.staticfiles",
    "django.contrib.gis",
    "sorl.thumbnail",
    "codex_app",
    "codex",
    "viz0",
    "viz1",
    "topo",
    # "debug_toolbar",
]

MIDDLEWARE = [
    # "debug_toolbar.middleware.DebugToolbarMiddleware",
    "django.middleware.security.SecurityMiddleware",
    "django.contrib.sessions.middleware.SessionMiddleware",
    "django.middleware.common.CommonMiddleware",
    "django.middleware.csrf.CsrfViewMiddleware",
    "django.contrib.auth.middleware.AuthenticationMiddleware",
    "django.contrib.messages.middleware.MessageMiddleware",
    "django.middleware.clickjacking.XFrameOptionsMiddleware",
]

ROOT_URLCONF = "codex_app.urls"

TEMPLATES = [
    {
        "BACKEND": "django.template.backends.django.DjangoTemplates",
        "DIRS": [],
        "APP_DIRS": True,
        "OPTIONS": {
            "context_processors": [
                "django.template.context_processors.debug",
                "django.template.context_processors.request",
                "django.contrib.auth.context_processors.auth",
                "django.contrib.messages.context_processors.messages",
            ],
        },
    },
]

WSGI_APPLICATION = "codex_app.wsgi.application"

# Database
# https://docs.djangoproject.com/en/3.2/ref/settings/#databases

DATABASES = {
    "default": {
        "ENGINE": "django.db.backends.sqlite3",
        "NAME": BASE_DIR / "db.sqlite3",
    },
    "digikam": {
        "ENGINE": "django.db.backends.sqlite3",
        "NAME": "/home/pierre/tmp/digikam4.db",
    },
}

# Password validation
# https://docs.djangoproject.com/en/3.2/ref/settings/#auth-password-validators

AUTH_PASSWORD_VALIDATORS = [
    {
        "NAME": "django.contrib.auth.password_validation.UserAttributeSimilarityValidator",
    },
    {
        "NAME": "django.contrib.auth.password_validation.MinimumLengthValidator",
    },
    {
        "NAME": "django.contrib.auth.password_validation.CommonPasswordValidator",
    },
    {
        "NAME": "django.contrib.auth.password_validation.NumericPasswordValidator",
    },
]

# Internationalization
# https://docs.djangoproject.com/en/3.2/topics/i18n/

LANGUAGE_CODE = "en-us"

TIME_ZONE = "UTC"

USE_I18N = True

USE_L10N = True

USE_TZ = True

# Static files (CSS, JavaScript, Images)
# https://docs.djangoproject.com/en/3.2/howto/static-files/

STATIC_URL = "/static/"

# Default primary key field type
# https://docs.djangoproject.com/en/3.2/ref/settings/#default-auto-field

DEFAULT_AUTO_FIELD = "django.db.models.BigAutoField"


MEDIA_ROOT = ""
MEDIA_URL_DEV = "/medias/"
MEDIA_URL = "/medias/"

import logging
import os

LOGGING = {
    "version": 1,
    "disable_existing_loggers": False,
    "handlers": {
        "console": {
            "class": "logging.StreamHandler",
        },
        # "f": {
        #     "level": logging.INFO,
        #     "class": "logging.FileHandler",
        #     "filename": "./sdi.log",
        # },
        # "file.db": {
        #     "level": logging.DEBUG,
        #     "class": "logging.FileHandler",
        #     "filename": "./db.log",
        # },
        # "logstash": {
        #     "level": logging.INFO,
        #     "class": "logstash.TCPLogstashHandler",
        #     "host": "127.0.0.1",
        #     "port": 5959,  # Default value: 5959
        #     "version":
        #     # Version of logstash event schema. Default value: 0 (for backward compatibility of the library)
        #     1,
        #     "message_type":
        #     # 'type' field in logstash message. Default value: 'logstash'.
        #     "django",
        #     "fqdn": False,  # Fully qualified domain name. Default value: false.
        #     "tags": ["django.request", "django"],  # list of tags. Default: None.
        # },
    },
    "loggers": {
        "django": {
            "handlers": ["console"],
            "level": os.getenv("DJANGO_LOG_LEVEL", "INFO"),
        },
        "django.request": {
            "handlers": ["console"],
            "level": logging.INFO,
            "propagate": True,
        },
        # "django.db": {
        #     "handlers": ["console"],
        #     "level": logging.DEBUG,
        #     "propagate": True,
        # },
        # 'pycsw.server': {
        #     'handlers': ['console'],
        #     'level': logging.DEBUG,
        #     'propagate': True,
        # },
        # 'activity': {
        #     'handlers': ['logstash'],
        #     #   'handlers': ['console'],
        #     'level': logging.INFO,
        #     'propagate': True,
        # },
    },
}


# CACHES = {
#     "default": {
#         "BACKEND": "django.core.cache.backends.dummy.DummyCache",
#     }
# }
